#ifndef LASER_H_
#define LASER_H_

#include <vector>
#include "Sprite.h"

class Player;
class Enemy;
class Laser : public Sprite
{
private:
	float xVelocity;
	float yVelocity;
	bool playerLaser;
public:
	Laser();
	Laser(const Laser& laser);
	Laser(std::string initialImagePath, float initialImageWidth, float initialImageHeight, float initalX, float initialY, float initialZ, float initialWidth, float initialHeight, float initialXVelocity, float initialYVelocity, bool initialPlayerLaser);
	void move(float xVelocity, float yVelocity, std::vector<Player> &players, std::vector<Enemy> &enemies);
	void move(std::vector<Player> &players, std::vector<Enemy> &enemies);
	void setVelocities(float newXVelocity, float newYVelocity);
	void setPlayerLaser(bool newPlayerLaser);
	bool getPlayerLaser();
};

#endif
