#ifndef MENU_H_
#define MENU_H_

class Menu
{
private:
	Menu(); //Disallow default constructor
	int index;
	int maxIndex;
	int numberOfTicks;
public:
	Menu(int initialMaxIndex);
	void moveCursor(bool direction);
	int getCursorIndex() const;
	void incrementNumberOfTicks();
	void resetNumberOfTicks();
	int getNumberOfTicks() const;

};

#endif
