#include "../HeaderFiles/Path.h"

void createPaths(std::vector<Path> &paths)
{
	Path path;

	path.addPoint(Point(280, 460));
	path.addPoint(Point(260, 450));
	path.addPoint(Point(240, 440));
	path.addPoint(Point(230, 420));
	path.addPoint(Point(220, 400));
	path.addPoint(Point(220, 380));
	path.addPoint(Point(230, 360));
	path.addPoint(Point(240, 340));
	path.addPoint(Point(260, 330));
	path.addPoint(Point(280, 320));
	path.addPoint(Point(300, 310));
	path.addPoint(Point(320, 300));
	path.addPoint(Point(330, 280));
	path.addPoint(Point(340, 260));
	path.addPoint(Point(340, 240));
	path.addPoint(Point(330, 220));
	path.addPoint(Point(320, 200));
	path.addPoint(Point(300, 190));
	path.addPoint(Point(280, 180));

	paths.push_back(path);
	path.clearPath();

	path.addPoint(Point(360, 460));
	path.addPoint(Point(380, 450));
	path.addPoint(Point(400, 440));
	path.addPoint(Point(410, 420));
	path.addPoint(Point(420, 400));
	path.addPoint(Point(420, 380));
	path.addPoint(Point(410, 360));
	path.addPoint(Point(400, 340));
	path.addPoint(Point(380, 330));
	path.addPoint(Point(360, 320));
	path.addPoint(Point(340, 310));
	path.addPoint(Point(320, 300));
	path.addPoint(Point(310, 280));
	path.addPoint(Point(300, 260));
	path.addPoint(Point(300, 240));
	path.addPoint(Point(310, 220));
	path.addPoint(Point(320, 200));
	path.addPoint(Point(340, 190));
	path.addPoint(Point(360, 180));

	paths.push_back(path);
	path.clearPath();

	for (int i = 0; i < 29; ++i)
		path.addPoint(Point(640 - i * 20, 480 - i * 10));

	paths.push_back(path);
	path.clearPath();

	for (int i = 0; i < 29; ++i)
			path.addPoint(Point(0 + i * 20, 480 - i * 10));

	paths.push_back(path);
	path.clearPath();

	for (int i = 0; i < 29; ++i)
		path.addPoint(Point(LEFT_BOUNDARY_X + i * 20, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT));

	for (int i = 0; i < 14; ++i)
		path.addPoint(Point(LEFT_BOUNDARY_X + 28 * 20, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - i * 20));

	paths.push_back(path);
	path.clearPath();

	for (int i = 0; i < 29; ++i)
		path.addPoint(Point(RIGHT_BOUNDARY_X - SPRITE_ENEMY_WIDTH - i * 20, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT));

	for (int i = 0; i < 14; ++i)
		path.addPoint(Point(RIGHT_BOUNDARY_X - SPRITE_ENEMY_WIDTH - 28 * 20, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - i * 20));

	paths.push_back(path);
	path.clearPath();

	for (int i = 0; i < 14; ++i)
		path.addPoint(Point(LEFT_BOUNDARY_X, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - i * 20));

	for (int i = 0; i < 14;++i)
		path.addPoint(Point(LEFT_BOUNDARY_X + i * 22, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - 13 * 20 + i * 20));

	for (int i = 0; i < 14; ++i)
			path.addPoint(Point(LEFT_BOUNDARY_X + 13 * 22 + i * 22, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - i * 20));

	for (int i = 0; i < 14; ++i)
			path.addPoint(Point(LEFT_BOUNDARY_X + 26 * 22, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - 13 * 20 + i * 20));

	paths.push_back(path);
	path.clearPath();

	for (int i = 0; i < 14; ++i)
		path.addPoint(Point(RIGHT_BOUNDARY_X - SPRITE_ENEMY_WIDTH, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - i * 20));

	for (int i = 0; i < 14;++i)
		path.addPoint(Point(RIGHT_BOUNDARY_X - SPRITE_ENEMY_WIDTH - i * 22, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - 13 * 20 + i * 20));

	for (int i = 0; i < 14; ++i)
			path.addPoint(Point(RIGHT_BOUNDARY_X - SPRITE_ENEMY_WIDTH - 13 * 22 - i * 22, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - i * 20));

	for (int i = 0; i < 14; ++i)
			path.addPoint(Point(RIGHT_BOUNDARY_X - SPRITE_ENEMY_WIDTH - 26 * 22, BOTTOM_BOUNDARY_Y - SPRITE_ENEMY_HEIGHT - 13 * 20 + i * 20));

	paths.push_back(path);
	path.clearPath();
}

Path::Path()
{
}

void Path::addPoint(Point p)
{
	points.push_back(p);
}

Point Path::getPoint(int currentPointIndex)
{
	if (!isDone(currentPointIndex))
		return points[currentPointIndex];

	return points[points.size() - 1];
}

bool Path::isDone(int currentPointIndex)
{
	if (currentPointIndex >= (signed) points.size())
		return true;

	return false;
}

void Path::clearPath()
{
	points.clear();
}
