#ifndef COLLISIONS_H_
#define COLLISIONS_H_

#include "Utility.h"

struct BoundingBox
{
	BoundingBox(float initialX1, float initialY1, float initialX2, float initialY2) :
		x1(initialX1),
		y1(initialY1),
		x2(initialX2),
		y2(initialY2)
		{}
	float x1;
	float y1;
	float x2;
	float y2;
};

bool RectangularCollisionDetection(BoundingBox box1, BoundingBox box2);
void NormalizeCoordinates(BoundingBox &box);

#endif
