#ifndef INPUT_STATE_H_
#define INPUT_STATE_H_

#include "Globals.h"

struct InputState
{
	InputState(); //Definition in input.cpp
	void reinitializeInputState(); //Definition in input.cpp
	//An array of 4 stands for MAX_PLAYERS
	bool CUp[4];
	bool CDown[4];
	bool CLeft[4];
	bool CRight[4];
	float CJoyY[4];
	float CJoyX[4];
	bool CLeftTrigger[4];
	bool CRightTrigger[4];
	bool CStart[4];
	bool CA[4];
	bool CB[4];
	bool CStartReady[4]; //Only tapping the start button should modify the state, thus the need for this variable
	bool CAReady[4];
	bool CLeftFireReady[4];
	bool CRightFireReady[4];
	int CLeftFireTicks[4];
	int CRightFireTicks[4];
	int CMoveTicks[4];
	int CATicks[4];
};

#endif
