#ifndef PATH_H_
#define PATH_H_

#include <vector>
#include "Globals.h"

class Path;
void createPaths(std::vector<Path> &paths);

struct Point
{
	Point(float newX, float newY) : x(newX), y(newY)
	{}

	float x;
	float y;
};

class Path
{
private:
	std::vector<Point> points;

public:
	Path();
	void addPoint(Point p);
	Point getPoint(int currentPointIndex);
	bool isDone(int currentPointIndex);
	void clearPath();
};

#endif
