#ifndef VIDEO_H
#define VIDEO_H

#include <kos.h>
#include <png/png.h>
#include <jpeg/jpeg.h>
#include <string>

void loadImage(pvr_ptr_t *image, std::string path, float width, float height);
void loadImageArray(pvr_ptr_t **image, std::string path, float width, float height);
void freeImage(pvr_ptr_t *image);
void freeImageArray(pvr_ptr_t **images);
void drawImage(const pvr_ptr_t &image, float x, float y, float layer, float width, float height);

#endif
