#include "../HeaderFiles/Globals.h"
#include "../HeaderFiles/Utility.h"

void swap(float &val1, float &val2)
{
    float tmp = val1;
    val1 = val2;
    val2 = tmp;
}

int pow(int operand, int exponent)
{
    int result = 1;
    int i = 0;
    for (i = 0; i < exponent; ++i)
        result *= operand;

    return result;
}

float abs(float num)
{
	if (num> 0)
		return num;
	else
		return -num;
}

void integerToString(int numToConvert, char *convertedString)
{
	const int OFFSET = 48;
	int index = 0;

	while (true)
	{
		//The tens digit is a special case because it signifies the end of the loop
		if (numToConvert < 10)
		{
			convertedString[index++] = (char)(numToConvert + OFFSET);
			convertedString[index] = '\0';
			break;
		}

		//Insert the current digit into the string
		convertedString[index++] = (char)((numToConvert % 10) + OFFSET);

		//Cut off the digit that was just read
		numToConvert -= numToConvert % 10;
		numToConvert /= 10;
	}

	reverseString(convertedString);
}

void reverseString(char *stringToReverse)
{
	const int OFFSET = 1;
	char newString[1024];
	int numCharacters = stringLength(stringToReverse) - 1; //Subtract 1 because we don't want to count the null terminating character
	int i = 0;

	for (i = 0; i < numCharacters; ++i)
		newString[i] = stringToReverse[numCharacters - (i + OFFSET)]; //OFFSET indecates that we don't want to include the null terminating character

	newString[numCharacters] = '\0';
	stringCopy(stringToReverse, newString);
}

int stringLength(char *stringToCheck)
{
	int index = 0;

	while(stringToCheck[index++]);

	return index;
}

void stringCopy(char *destination, char *source)
{
	int index = 0;

	while(source[index])
	{
		destination[index] = source[index];
		++index;
	}

	destination[index] = '\0';
}
